' SCE (Chip Select) Pin 2
' RST (Reset) Pin 4
' D/C (data command) Pin 5
' (mosi) SPI Out pin 3
' SCLK (SPI Clock) Pin 25

SetPin 2, 8 'Digital Output for SPI Chip Select
SetPin 4, 8 'Digital Output for LCD RST
SetPin 5, 8 'Digital Output for LCD D/C

Pin(2) = 1 ' Enable High
Pause 25

Pin(2) = 0 ' Enable is active low
SPI Open 1000000, 3, 8 'Setup SPI

DC = 5
RST = 4

Dim Codes(504)

GoSub Codes
GoSub LCD_INIT
GoSub LCD_Clear
GoSub Graphics
End


LCD_Init:

Pin(RST) = 0 : Pause 15 : Pin(RST) = 1 : Pin(DC) = 0  ' RESET LCD
  LcdData= &H21 : GoSub LCD_ByteOut        ' LCD EXTENDED COMMANDS
Pause 20
  LcdData= &HC8 : GoSub LCD_ByteOut        ' SET LCD Vop (CONTRAST)
Pause 20
  LcdData= &H06 : GoSub LCD_ByteOut        ' SET TEMP COEFFICENT
Pause 20
  LcdData= &H13 : GoSub LCD_ByteOut        ' LCD BIAS MODE
Pause 20
  LcdData= &H20 : GoSub LCD_ByteOut        ' LCD STANDARD COMMANDS
Pause 20
  LcdData= &H0C : GoSub LCD_ByteOut        ' LCD IN NORMAL MODE
Pause 20
Return

LCD_ByteOut:
 Junk =  SPI(LcdData)        ' datapin clock pin mode Var
Return

LCD_CharOut:

Pin(DC) = 1
bitmap = ((LcdData - 32) * 6)

If Font = 1 Then
If LcdData=46 Then LcdData=LcdData+12
BitMap=((LcdData - 48)*24) + 552 ' Numbers only
EndIf

If font = 0 Then BitMapSize=6
If font = 1 Then BitMapSize=12

 For I = Bitmap To (BitMap+BitMapsize-1)
   Junk = SPI(Codes(I))
 Next I
Counter=I

If BitMapSize=12 Then

PosY=PosY+1:GoSub LCD_GotoXY
For I = Counter To ((Counter+BitMapSize)-1)
   Junk = SPI(Codes(I))
 Next I
Counter = I

PosY=PosY-1:PosX=PosX+12:GoSub LCD_GotoXY
EndIf

Return

LCD_StringOut:
  For CharCount=1 To Len(Text$)
      LcdData=LCDstr(CharCount)
      GoSub LCD_CharOut
  Next CharCount
Return

LCD_Clear:
  PosX=0:PosY=0:GoSub LCD_GotoXY
  Pin(DC)=1
  For Chr=1 To 252
      LcdData=0 : GoSub LCD_ByteOut
      LcdData=0 : GoSub LCD_ByteOut
  Next Chr
Return

LCD_GotoXY:
Pin(DC) = 0
  LcdData=&B01000000 Or PosY : GoSub LCD_ByteOut
  LcdData=&B10000000 Or PosX : GoSub LCD_ByteOut
  Pin(DC) = 1
Return


Sub Lookup
 For Chr= 1 To Len(Text$)
 Bitmap =  Asc(Mid$(Text$, Chr, 1))
      LCDstr(Chr)= BitMap
 Next Chr
End Sub

Graphics:

 PosY = 0 : PosX = 0
 GoSub LCD_GotoXY
  Pin(DC) = 1

  For I = 0 To 503
   Junk = SPI(Codes(I))
 Next I

 Pin(DC) = 0

Return

Codes:
For I = 0 To 503
 Read Codes(I)
Next I
Return

Data &HE0,&HF0,&HF0,&HF8,&HF8,&H38,&H38,&H38,&H38,&H38,&H38,&H38
Data &H38,&H78,&H70,&HF0,&HF0,&HE0,&HE0,&HC0,&HC0,&H80,&H80,&H00
Data &H00,&H00,&H00,&H80,&H40,&H20,&H10,&H90,&H10,&H50,&H50,&H90
Data &HD0,&HF0,&H08,&HF0,&H10,&H10,&H10,&H10,&H20,&H20,&H20,&H20
Data &H40,&HC0,&HC0,&HE0,&HE0,&HE0,&HF0,&HF0,&HF8,&HF8,&HF8,&HFC
Data &HFE,&HFE,&H0F,&HF0,&H3F,&H00,&H00,&H00,&H00,&H00,&H00,&H00
Data &H00,&H00,&H00,&H00,&H00,&H00,&H00,&H00,&H00,&H00,&H00,&H00
Data &H01,&H03,&H07,&H0F,&H0F,&H1F,&H9F,&HBE,&HFE,&HFC,&HFC,&HF8
Data &HF8,&HF8,&HF0,&HF0,&HF0,&HF9,&HF9,&HFB,&HFF,&HFF,&HFF,&HFF
Data &HFE,&HFC,&HF0,&HC3,&H04,&H08,&H8A,&HC4,&H65,&H3A,&H4D,&H06
Data &H02,&H02,&H01,&H01,&H03,&H02,&H04,&H00,&H00,&H00,&H00,&HC0
Data &HF8,&HFF,&HFF,&HFF,&HFF,&HFF,&HFF,&HFF,&HFF,&HFF,&HFF,&HFF
Data &H7F,&H3F,&H80,&HFF,&HFF,&H00,&H00,&H00,&H00,&H00,&H00,&H00
Data &H80,&HC0,&HE0,&HE0,&HE0,&HF0,&HF0,&HF0,&HF0,&HF0,&HE0,&HC0
Data &H00,&H7C,&HFE,&HFE,&HFE,&H8F,&H07,&H07,&HC7,&H23,&H23,&H23
Data &H63,&HA3,&HE3,&HE7,&HC7,&H07,&H00,&HC0,&H20,&H60,&HE0,&HC0
Data &H40,&H81,&H03,&H07,&H3E,&HEF,&HC1,&H80,&H00,&H00,&H00,&H00
Data &H00,&H00,&HA0,&H50,&H70,&H40,&H30,&H00,&H1C,&H22,&HC1,&H03
Data &H07,&H1F,&H3F,&HFF,&HFF,&HFF,&HFF,&HFF,&HFF,&HFF,&HFF,&H71
Data &H10,&H1C,&H1F,&H1F,&H0F,&H04,&H04,&H02,&H02,&H82,&H41,&H21
Data &H11,&H0B,&H0F,&H0F,&H07,&H07,&H07,&H07,&H07,&H07,&H03,&H01
Data &H00,&H00,&H0C,&H1D,&H1F,&H1F,&H3F,&H3E,&H7C,&H59,&H51,&H62
Data &HA2,&HE2,&HE2,&H42,&HE2,&H11,&HF0,&HF0,&HE0,&H00,&H00,&H01
Data &H0F,&H9E,&HC3,&HE0,&HF0,&HFF,&H7F,&H3F,&H00,&H00,&H00,&H10
Data &HB0,&H55,&H53,&H55,&H15,&H05,&H01,&H00,&H00,&H00,&H10,&H0F
Data &H00,&H00,&H00,&H00,&H01,&H01,&H0F,&H31,&HC3,&H0F,&HFF,&HFF
Data &HFE,&HFE,&HFC,&HFC,&H7C,&H3C,&H1C,&H12,&H11,&H20,&H20,&H20
Data &H10,&HF0,&HF8,&HFC,&HFC,&HFC,&HF8,&HF8,&HF0,&HC0,&H00,&H00
Data &H00,&H00,&H00,&H00,&H00,&H00,&H00,&H00,&H00,&H00,&H00,&H00
Data &H00,&H00,&H00,&HC1,&H22,&H25,&H15,&H55,&H34,&HA4,&H54,&HA2
Data &H42,&H01,&H03,&HFF,&H08,&H00,&H00,&H00,&H40,&H80,&H80,&H29
Data &H29,&H29,&H35,&H21,&H21,&H00,&H80,&H40,&H00,&H80,&H80,&H80
Data &HC0,&HE0,&HE0,&HF0,&HF8,&HF8,&HFC,&HFC,&HFF,&HFC,&HFF,&H7B
Data &H01,&H03,&H04,&H04,&H04,&H08,&H08,&H08,&H08,&H08,&H04,&H04
Data &H02,&H03,&H1F,&H3F,&H7F,&HFF,&HFF,&H7F,&H7F,&H1F,&H00,&H00
Data &H00,&H00,&H00,&H00,&H00,&H00,&H00,&H00,&H00,&H00,&H00,&H00
Data &H00,&H00,&H00,&H00,&H03,&H04,&H08,&H08,&H11,&H14,&H24,&H32
Data &H2D,&H54,&H4C,&H84,&H85,&H86,&H84,&H80,&H80,&H80,&H80,&H81
Data &H81,&H41,&H21,&H19,&H07,&H01,&H01,&H01,&H03,&H03,&H03,&H07
Data &H07,&H07,&H0F,&H0F,&H0F,&H1F,&H1F,&H1F,&H1F,&H3F,&H3F,&H3E
Data &H3C,&H38,&H20,&H00,&H00,&H00,&H00,&H00,&H00,&H00,&H00,&H00
Data &H00,&H00,&H00,&H00,&H00,&H00,&H00,&H00,&H00,&H00,&H00,&H00